function [ X,y,C,x,h,g,z,y1,y_noise,idx,X0_dc ] = generate_model( Ksize,sparse) 
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here
Ksize = num2cell(Ksize,1);

[n1,n2,S,R,m,sigma] = deal(Ksize{:});

[h,g,X,y1,y2] = deal(cell(R,S));
[x,z,C] = deal(cell(S,1));

F = dftmtx(m)/sqrt(m);
idx = randperm(S,sparse);

for jS = 1:S
    if  any(jS==idx)
       x{jS} = zeros(n1,1);
    else
       x{jS} = (randn(n1,1)+1i*randn(n1,1))/sqrt(2);
    end
     C{jS} = (randn(m,n1)+1i*randn(m,n1));
     z{jS} = C{jS}*x{jS};
for iR = 1:R
    
      h{iR,jS} = (randn(n2,1)+1i*randn(n2,1))/sqrt(2);
      g{iR,jS} = [h{iR,jS};zeros(m-n2,1)];
     
      X{iR,jS} = x{jS}*conj(h{iR,jS}');
  
      y1{iR,jS} = cconv(z{jS},g{iR,jS},m);
      y2{iR,jS} = F*y1{iR,jS}/sqrt(m);
end
end

 y = reshape(arrayfun(@(len)sum(cat(3,y2{len,:}),3),1:R,'Uni',0),[R,1]);
 e = reshape(arrayfun(@(len)(randn(m,1)+1i*randn(m,1))/sqrt(2),1:R,'Uni',0),[R,1]);
 e = cellfun(@(x,z)x/norm(x)*sigma*norm(z),e,y,'Uni',0);
 y_noise = cellfun(@(x,z)x+z,e,y,'Uni',0);
 y_noise = horzcat(y_noise{:});
 y = horzcat(y{:});
 X0_dc = reshape(arrayfun(@(len)(randn(n1,1)+1i*randn(n1,1))*(randn(n2*R,1)+1i*randn(n2*R,1))',1:S,'Uni',0),[S,1]);
 X = reshape(arrayfun(@(len) horzcat(X{:,len}),1:S,'Uni',0),[S,1]);
 
end

