function [Xreturn,X] = convex_cvx1( Ksize, A, b,lambda_n,lambda_f,lambda_s)
m=Ksize(1); n=Ksize(2); K = Ksize(3); d = Ksize(4);

f=@(X)cost(X,A,b);
N=@(X)Nx(X,K,lambda_n,lambda_f,lambda_s);
cvx_begin quiet
  cvx_expert true
    variable X(m,n,K) complex 
      minimize  N(X)
      subject to 
               f(X)<=1e-30

cvx_end

Xreturn=cell(K,1);
for i = 1:K
  Xreturn{i} = X(:,:,i);
end


end
function fx = cost(X,A,b)  
     sum_Ax = zeros(size(b,1),1);
     for ik = 1:size(X,3)
        x = X(:,:,ik);
        sum_Ax  = sum_Ax + A{ik}*x(:);        
     end
      fx =norm(sum_Ax-b,2);

end
function n = Nx(X,K,lambda_n,lambda_f,lambda_s)
n = 0;
for i = 1:K
    n = n + lambda_n*norm_nuc(X(:,:,(i)))+lambda_f*norm(X(:,:,i),'fro')+lambda_s*norm_1_2(X(:,:,i));
end
end
function y = norm_1_2(X)
y = 0;
for i =  1:size(X,2)
y = y + norm(X(:,i));
end
end