function [A,B,FC,Ck]= generate_decon_matrix(m,n1,n2,K,C,x,h,yy)
% B m x n2 low-frequemcy DFT
% A n1 x n2 x*h^*
% Detailed explanation goes here
A = cell(K,1);
FC = cell(K,1);
F = dftmtx(m)/sqrt(m);
B = F(:,1:n2);
for k=1:K
    Ck = F*C{k};
    FC{k} = Ck;
    Ak=zeros(m,n1*n2);
    for ri=1:m
        tmp = Ck(ri,:)'*conj(B(ri,:));
%         y(ri)  = Ck(ri,:)* x{k}*conj(h{k}')*conj(B(ri,:))';
        Ak(ri,:)=tmp(:)';
       
        
    end
    A{k} = Ak;
  
end
% A.Af = @myAf;
%     function y = myAf(X)
%         y = zeros(m*K,1);
%         for k=1:K
%             y((k-1)*m+1:k*m) = A((k-1)*m+1:k*m,:)*X{k};
%         end
%     end
% A.Aft = @myAft;
%     function X = myAft(y)
%         X = cell(K,1);
%         y = zeros(m*K,1);
%         for k=1:K
%             y((k-1)*m+1:k*m) = A((k-1)*m+1:k*m,:)*X((k-1)*n1+1:k*n1,:);
%         end
%     end
end

