function x=solve_cvx(A,b,mu,constrain_value)
d=size(A,2);
n=size(b,2);
cvx_begin quiet

    variable x(d,n) complex
    expression xx(d) 
    for ii = 1:d
        xx(ii) = norm(x(ii,:));
    end
    h=norm(A*x-b,'fro');
%     minimize( norm(xx,1)+0.5*mu*norm(xx,2)^2)
%     subject to
%         norm(A*x-b,'fro')<=eps;
    minimize (pow_pos(h,2))
    subject to
          sum(xx) <= constrain_value;       
cvx_end

end